package com.yc.ship.module.miniapplet.service.advert;

import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.miniapplet.controller.admin.advert.vo.AdvertPageReqVO;
import com.yc.ship.module.miniapplet.controller.admin.advert.vo.AdvertSaveReqVO;
import com.yc.ship.module.miniapplet.dal.dataobject.advert.AdvertDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 广告管理 Service 接口
 *
 * @author 管理员
 */
public interface AdvertService {

    /**
     * 创建广告管理
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createAdvert(@Valid AdvertSaveReqVO createReqVO);

    /**
     * 更新广告管理
     *
     * @param updateReqVO 更新信息
     */
    void updateAdvert(@Valid AdvertSaveReqVO updateReqVO);

    /**
     * 删除广告管理
     *
     * @param id 编号
     */
    void deleteAdvert(Long id);

    /**
     * 获得广告管理
     *
     * @param id 编号
     * @return 广告管理
     */
    AdvertDO getAdvert(Long id);

    /**
     * 获得广告管理分页
     *
     * @param pageReqVO 分页查询
     * @return 广告管理分页
     */
    PageResult<AdvertDO> getAdvertPage(AdvertPageReqVO pageReqVO);

    /**
     * 根据广告位查广告
     *
     * @param adsenseId
     * @return
     */
    List<AdvertDO> getAdvertList(Long adsenseId);

    /**
     * 根据广告位Id获取可以使用的广告
     * @param adsenseId
     * @return
     */
    List<AdvertDO> getCanUseAdvertList(Long adsenseId);
}
